﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package {
	import org.osmf.elements.VideoElement;
	import org.osmf.net.DynamicStreamingItem;
	import org.osmf.net.DynamicStreamingResource;
	import org.osmf.media.MediaPlayerSprite;
	import org.osmf.traits.MediaTraitType;
	import org.osmf.traits.LoadTrait;
	import org.osmf.layout.ScaleMode;
	import org.osmf.layout.LayoutMetadata;
	import org.osmf.elements.ImageElement;
	import org.osmf.utils.OSMFSettings;
	import org.osmf.events.TimeEvent;
	import org.osmf.containers.MediaContainer;
	import org.osmf.media.MediaPlayer;
	import org.osmf.media.URLResource;

	import com.actionscriptfacile.ui.text.UITextField;
	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	
	[SWF(backgroundColor="0x000000")] // definit la couleur de fond du swf
	//[SWF(width="550", height="400")] // définit la taille du swf
	
	public class Main extends Sprite
	{		
		private static const LOGO_PNG : String = "http://www.actionscript-facile.com/wp-content/uploads/2011/10/logo-as3.jpg";// l'url de l'image de la vidéo
		
		private static const URL_ROOT_STREAMING:String = "rtmp://s9teld733sjgz.cloudfront.net/cfx/st/";// le chemin de base des vidéos en streaming

		private static const URL_FILE_STREAMING:String = "mp4:fichiers/tony-robbins-upw";// la vidéo en streaming

	
		private var oInfosDuration : UITextField;// texte de durée écoulée
		
		private var oMediaPlayerSprite:MediaPlayerSprite;// pour afficher le player
		private var mediaContainer : MediaContainer;// container de la vidéo
		
		
		private var oTrackVideo:Sprite;// barre d'indication de la vidéo
		private var oPisteVideo:Sprite;// barre avance rapide de la vidéo
		private var oProgressPlayVideo:Sprite;// barre de progression de la lecture de la vidéo
		
		

		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, this, "Start Streaming Vidéo");
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{			
			var oMultiMedia:DynamicStreamingResource = initStream();// récupère le flux en streaming
			var oLogo:ImageElement = addPlayerPicture();
			
			addPlayerVideo(oLogo, oMultiMedia);
			addPlayerCommand();
		}
		
		
		/**
		 * Création du flux vidéo en streaming.
		 * 
		 */
		protected function initStream() : DynamicStreamingResource
		{
			// défini l'url de base du flux de streaming
			var oStreamVideos:DynamicStreamingResource = new DynamicStreamingResource( URL_ROOT_STREAMING );
			
			// ajoute les vidéos en streaming - chemin, bitrate, largeur, hauteur de la vidéo
			oStreamVideos.streamItems.push( new DynamicStreamingItem( URL_FILE_STREAMING, 600, 480, 360  ) );
			oStreamVideos.urlIncludesFMSApplicationInstance = true;// pour activer le streeaming avec amazon S3 et CloudFront
			
			return oStreamVideos;
		}
		
		
		/**
		 * Ajoute une image au dessus de la vidéo
		 * 
		 */
		private function addPlayerPicture() : ImageElement
		{
			// création de l'image de présentation de la vidéo
			var oWatermark:ImageElement = new ImageElement( new URLResource(LOGO_PNG) );
			oWatermark.smoothing = true;
			
			// Création d'un layout pour le logo			
			var logoLayout:LayoutMetadata = new LayoutMetadata();
			oWatermark.addMetadata(LayoutMetadata.LAYOUT_NAMESPACE, logoLayout);
			
			// réduit la taille de l'image
			logoLayout.height = 70;
			logoLayout.width = 70;

			// positionne l'image en bas à droite du container de la vidéo
			logoLayout.bottom = 0;
			logoLayout.right = 0;					
					
			// Conserve les proportions de l'image
			logoLayout.scaleMode = ScaleMode.LETTERBOX;
			
			var oLoadTrait:LoadTrait = oWatermark.getTrait( MediaTraitType.LOAD ) as LoadTrait;
			oLoadTrait.load();// lance le chargement de l'image

			return oWatermark;
		}


		/**
		 * Ajoute le lecteur vidéo
		 * 
		 * @param oLogo : le logo à afficher par dessus la vidéo.
		 * 
		 */
		private function addPlayerVideo(oLogo:ImageElement, oMultiMedia:DynamicStreamingResource) : void
		{
			OSMFSettings.enableStageVideo = true;// désactive / active la fonctionnalité StageVideo (améliore les performances si active)

			var media:VideoElement = new VideoElement( oMultiMedia );// création de l'élément vidéo
			
			// le player
			var mediaPlayer:MediaPlayer = new MediaPlayer( media );
			mediaPlayer.addEventListener(TimeEvent.CURRENT_TIME_CHANGE, onCurrentTimeChangeHandler );
			
			
			// container de la vidéo
			mediaContainer = new MediaContainer();
			mediaContainer.addMediaElement( media );
			mediaContainer.addMediaElement( oLogo );
 			mediaContainer.width = stage.stageWidth;// la taille du container de la vidéo
 			//mediaContainer.height = stage.stageHeight - 50;// la taille du container de la vidéo
 			
			// pour afficher le player
			oMediaPlayerSprite = new MediaPlayerSprite( mediaPlayer, mediaContainer );
			
			oMediaPlayerSprite.media = media;
			oMediaPlayerSprite.addEventListener( MouseEvent.CLICK, onPlayPauseClick, false, 0, true );// clique sur la vidéo pour la mettre en pause / lecture
			addChild( oMediaPlayerSprite );
		}


		/**
		 * Ajoute les boutons du Player
		 * 
		 */
		private function addPlayerCommand() : void
		{
			addMediaPlayerTracks( stage.stageWidth, 10 );// ajoute les barres avance rapide du player			
			
			// durée de la vidéo
			oInfosDuration = this.addText("00:00");
			oInfosDuration.x = 432;
			oInfosDuration.y = 375;
			this.addChild(oInfosDuration);
			
			
			// Création des boutons
			var oBtnPlayPause:DefaultButton = new DefaultButton();
			oBtnPlayPause.getObject().label = "Play / Pause";
			oBtnPlayPause.getObject().x = 10;
			oBtnPlayPause.getObject().y = oInfosDuration.y;
			oBtnPlayPause.getObject().addEventListener ( MouseEvent.CLICK, onPlayPauseClick );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			this.addChild(oBtnPlayPause);
			
			
			var oBtnMute:DefaultButton = new DefaultButton();
			oBtnMute.getObject().label = "Audio on/off";
			oBtnMute.getObject().x = oBtnPlayPause.getObject().x + oBtnPlayPause.width + 10;
			oBtnMute.getObject().y = oInfosDuration.y;
			oBtnMute.getObject().addEventListener ( MouseEvent.CLICK, onToggleMuteClick );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			this.addChild(oBtnMute);
		}

 
 		/**
 		 * La barre pour naviguer dans la vidéo.
 		 * Création de la barre de progression.
 		 * 
 		 */
		private function addMediaPlayerTracks( nWidth:Number, nHeight:Number ):void
		{
			// barre d'indication de la vidéo
			oTrackVideo = new Sprite();
			oTrackVideo.mouseEnabled = false;// désactive le clique de l'utilisateur
			oTrackVideo.graphics.beginFill( 0x666666, 0.6 );// la couleur - transparence alpha
			oTrackVideo.graphics.drawRect( 0, 0, nWidth, nHeight );
			oTrackVideo.graphics.endFill();
			oTrackVideo.visible = false;// masquée par défaut
			addChild( oTrackVideo );
			
			
			// La barre pour l'avance rapide dans la vidéo.
			oPisteVideo = new Sprite();
			oPisteVideo.addEventListener(MouseEvent.CLICK, onTrackClickPlay, false, 0, true );
			oPisteVideo.graphics.beginFill( 0x696969, 0.8 );
			oPisteVideo.graphics.drawRect( 0, 0, nWidth, nHeight );
			oPisteVideo.graphics.endFill();
			oPisteVideo.visible = false;// masquée par défaut
			addChild( oPisteVideo );
			
			
			// Création de la barre de progression de lecture de la vidéo.
			oProgressPlayVideo = new Sprite();
			oProgressPlayVideo.mouseEnabled = false;// désactive le clique de l'utilisateur
			oProgressPlayVideo.graphics.beginFill( 0xffffff, 0.6 );
			oProgressPlayVideo.graphics.drawRect( 0, 0, nWidth, nHeight );
			oProgressPlayVideo.graphics.endFill();
			oProgressPlayVideo.visible = false;// masquée par défaut
			addChild( oProgressPlayVideo );	
		}
		
		
 
 		/**
 		 * Appel lorsque la vidéo est en lecture, durée écoulée.
 		 * 
 		 */
		private function onCurrentTimeChangeHandler( e:TimeEvent ):void
		{
			var nPourcent:Number = (e.time / oMediaPlayerSprite.mediaPlayer.duration ); 
			oProgressPlayVideo.scaleX = nPourcent;
			
			oInfosDuration.text = secondsToMinutes( e.time )+" / "+secondsToMinutes( oMediaPlayerSprite.mediaPlayer.duration );
			
			// affiche et positionne les barres "avance rapide"
			if( mediaContainer.height > 0 && !oProgressPlayVideo.visible)
			{
				oProgressPlayVideo.y = mediaContainer.height;
				oProgressPlayVideo.visible = true;
				
				oPisteVideo.y = oProgressPlayVideo.y;
				oPisteVideo.visible = true;
				
				oTrackVideo.y = oProgressPlayVideo.y;
				oTrackVideo.visible = true;
				
				oMediaPlayerSprite.mediaPlayer.pause();// désactive la lecture automatique
			}
		}
 	
 
 		/**
 		 * Clique de l'utilisateur sur la barre d'avance rapide.
 		 * 
 		 */
		private function onTrackClickPlay( e:MouseEvent ):void
		{
			MonsterDebugger.trace(this,  "onTrackClickPlay" );
			oMediaPlayerSprite.mediaPlayer.seek( (oTrackVideo.mouseX / oTrackVideo.width) * oMediaPlayerSprite.mediaPlayer.duration );
		}
 			
						
		/**
		 * Appel à chaque appui sur le bouton Play / Pause de la vidéo (ou sur la vidéo)
		 * 
		 */
		private function onPlayPauseClick(event : MouseEvent) : void
		{
			//MonsterDebugger.trace(this,  "onPlayPauseClick");
			// si la player est en lecture --> mise en pause
			if( oMediaPlayerSprite.mediaPlayer.playing )
				oMediaPlayerSprite.mediaPlayer.pause();
			else
				oMediaPlayerSprite.mediaPlayer.play();
		}

		
		/**
		 * Met le son au maximum ou en silence.
		 * 
		 */
		private function onToggleMuteClick(event:MouseEvent):void
		{
			oMediaPlayerSprite.mediaPlayer.muted = !oMediaPlayerSprite.mediaPlayer.muted;
		}

		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("bold", true);
			oTxtField.changeFormat("size", 15);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x00C5DF);// changement de la couleur
			
			return oTxtField;	 
		}		


		/**
		 * Converti des secondes en minutes - 153 secondes en 02:33
		 * 
		 * @param nValue : nombre de secondes
		 * @return : une chaine de caractère au format 00:00
		 */
		private function secondsToMinutes( nSeconds:uint) : String
		{
			var sTime:String;

			// si la durée de la vidéo est supérieur à 1h00
			if ( nSeconds >= 60 * 60 )
			{
				// Format-> H:MM:SS
				sTime = (Math.floor(nSeconds / (60 * 60))) + // Heures 
				":" + ("0" + Math.floor((nSeconds % (60 * 60)) / 60)).substr(-2) + // Minutes 
				":" + ("0" + (nSeconds % 60)).substr(-2);// Secondes
			}
			else
			{
				// Format-> MM:SS
				sTime = ("0" + Math.floor(nSeconds / 60)).substr(-2) + // Minutes 
				":" + ("0" + (nSeconds % 60)).substr(-2);// Secondes
			}
			return sTime;
		}

	}
}
